﻿


using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int SizeOfT(Type type)
  {
    var result = Marshal.SizeOf(type);
    result = type == typeof(char) ? 2 : result;
    result = type == typeof(bool) ? 1 : result;
    return result;
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int SizeOfT<T>() where T : struct
  {
    return SizeOfT(typeof(T));
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public unsafe static int SizeOfTUnmanaged<T>() where T : unmanaged
  {
    var result = sizeof(T);
    result = typeof(T) == typeof(char) ? 2 : result;
    result = typeof(T) == typeof(bool) ? 1 : result;
    return result;
  }
}
