﻿
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace exc.jdbi.Spans;


//Wichtig: Der gleiche Speicherbereich wird zurückgegeben
//Important: The same memory area is returned.


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ReadOnlySpan<byte> AsBytes<T>(ReadOnlySpan<T> span) where T : struct
  {
    //Return the same memory
    return MemoryMarshal.AsBytes(span);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<byte> AsBytes<T>(Span<T> span) where T : struct
  {
    //Return the same memory
    return MemoryMarshal.AsBytes(span);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ReadOnlySpan<byte> AsBytes<T>(ReadOnlySpan<T> span, int start) where T : struct
  {
    //Return the same memory
    return MemoryMarshal.AsBytes(span[start..]);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<byte> AsBytes<T>(Span<T> span, int start) where T : struct
  {
    return MemoryMarshal.AsBytes(span[start..]);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ReadOnlySpan<byte> AsBytes<T>(ReadOnlySpan<T> span, int start, int length) where T : struct
  {
    //Return the same memory
    return MemoryMarshal.AsBytes(span.Slice(start, length));
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<byte> AsBytes<T>(Span<T> span, int start, int length) where T : struct
  {
    //Return the same memory
    return MemoryMarshal.AsBytes(span.Slice(start, length));
  }
}
