﻿

using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ref readonly T AsRef<T>(ReadOnlySpan<byte> bytes) where T : struct
  {
    return ref MemoryMarshal.AsRef<T>(bytes);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ref T AsRef<T>(Span<byte> bytes) where T : struct
  {
    return ref MemoryMarshal.AsRef<T>(bytes);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ref readonly T AsRef<T>(ReadOnlySpan<byte> bytes, int start) where T : struct
  {
    return ref MemoryMarshal.AsRef<T>(bytes[start..]);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ref T AsRef<T>(Span<byte> bytes, int start) where T : struct
  {
    return ref MemoryMarshal.AsRef<T>(bytes[start..]);
  }

}
