﻿

using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static void Copy<TSrc, TDest>(
    ReadOnlySpan<TSrc> src, in int startsrc, Span<TDest> dst, in int startdst, in int countsrc)
    where TSrc : struct where TDest : struct
  {
    var sztdest = SizeOfT<TDest>();
    var bytes = MemoryMarshal.AsBytes(src.Slice(startsrc, countsrc));

    var startdstbytes = startdst * sztdest;
    var bytesdst = MemoryMarshal.AsBytes(dst);
    SpanCopyBytes(bytes, 0, bytesdst, startdstbytes, bytes.Length);
  }

}
