﻿
using System.Runtime.CompilerServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{
  //https://github.com/dotnet/runtime/issues/20107

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int BinarySearch<T>(ReadOnlySpan<T> span, T value) where T : IComparable<T>
  {
    //span muss sortiert sein
    return span.BinarySearch(value);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int BinarySearch<T>(Span<T> span, T value) where T : IComparable<T>
  {
    //span muss sortiert sein
    return span.BinarySearch(value);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int BinarySearch<T>(ReadOnlySpan<T> span, IComparable<T> comparable)
  {
    //span muss sortiert sein
    return span.BinarySearch(comparable);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int BinarySearch<T>(Span<T> span, IComparable<T> comparable)
  {
    //span muss sortiert sein
    return span.BinarySearch(comparable);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int BinarySearch<T>(ReadOnlySpan<T> span, int start, IComparable<T> comparable)
  {
    //span muss sortiert sein
    var result = span[start..].BinarySearch(comparable);
    if (result < 1) return -1;
    return start + result;
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int BinarySearch<T>(Span<T> span, int start, IComparable<T> comparable)
  {
    //span muss sortiert sein
    var result = span[start..].BinarySearch(comparable);
    if (result < 1) return -1;
    return start + result;
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int BinarySearch<T>(ReadOnlySpan<T> span, int start, int length, IComparable<T> comparable)
  {
    //span muss sortiert sein
    var result = span.Slice(start, length).BinarySearch(comparable);
    if (result < 1) return -1;
    return start + result;
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static int BinarySearch<T>(Span<T> span, int start, int length, IComparable<T> comparable)
  {
    //span muss sortiert sein
    var result = span.Slice(start, length).BinarySearch(comparable);
    if (result < 1) return -1;
    return start + result;
  }

}
