﻿using System.Runtime.CompilerServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<T> Concat<T>(ReadOnlySpan<T> span1, ReadOnlySpan<T> span2)
  {
    //Alloc from Heap
    var result = new T[span1.Length + span2.Length];
    Copy(span1, 0, result, 0, span1.Length);
    Copy(span2, 0, result, span1.Length, span2.Length);
    return result;
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<T> Concat<T>(Span<T> span1, Span<T> span2)
  {
    //Alloc from Heap
    ReadOnlySpan<T> rospan1 = span1;
    ReadOnlySpan<T> rospan2 = span2;
    return Concat(rospan1, rospan2);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<T> Concat<T>(ReadOnlySpan<T> span1, Span<T> span2)
  {
    //Alloc from Heap
    ReadOnlySpan<T> rospan2 = span2;
    return Concat(span1, rospan2);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<T> Concat<T>(Span<T> span1, ReadOnlySpan<T> span2)
  {
    //Alloc from Heap
    ReadOnlySpan<T> rospan1 = span1;
    return Concat(rospan1, span2);
  }

}
