﻿

using System.Runtime.CompilerServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static object CreateInstance(Type itemtype, int size)
  {
    return Array.CreateInstance(itemtype, size);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static object CreateInstance(Type itemtype, int[] sizes, bool multi_array = true)
  {
    if (multi_array)
      return Array.CreateInstance(itemtype, sizes);

    //jagged
    var result = sizes.Select(x => Array.CreateInstance(itemtype, x)).ToArray();
    return result;
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<T> CreateInstance<T>(int size)
  {
    return new T[size];
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<T> CreateInstance<T>(long size)
  {
    return new T[size];
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<T[]> CreateInstance<T>(params int[] sizes)
  {
    var result = new T[sizes.Length][];
    for (var i = 0; i < result.Length; i++)
      result[i] = new T[sizes[i]]; 
    return result.AsSpan();
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<T[]> CreateInstance<T>(params long[] sizes)
  {
    var result = new T[sizes.Length][];
    for (var i = 0; i < result.Length; i++)
      result[i] = new T[sizes[i]];
    return result.AsSpan();
  }
}
