﻿
using System.Runtime.CompilerServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static void Reverse<T>(Span<T> span)
  {
    if (span.Length < 2) return;
    MemoryExtensions.Reverse(span);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static void Reverse<T>(Span<T> span, int start)
  {
    if (span.Length - start >= 2)
      MemoryExtensions.Reverse(span[start..]);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static void Reverse<T>(Span<T> span, int start, int length)
  {
    if (length < 2) return;
    MemoryExtensions.Reverse(span.Slice(start, length));
  }
}
