﻿

using System.Globalization;
using System.Runtime.CompilerServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<char> ToLower(ReadOnlySpan<char> span, CultureInfo? cultureInfo = null)
  {
    var result = new char[span.Length];
    var ci = cultureInfo is not null ? cultureInfo : CultureInfo.CurrentCulture;
    var c = MemoryExtensions.ToLower(span, result, ci);
    if (c == span.Length) return result;

    throw new InvalidOperationException(nameof(span));
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<char> ToUpper(ReadOnlySpan<char> span, CultureInfo? cultureInfo = null)
  {
    var result = new char[span.Length];
    var ci = cultureInfo is not null ? cultureInfo : CultureInfo.CurrentCulture;
    var c = MemoryExtensions.ToUpper(span, result, ci);
    if (c == span.Length) return result;

    throw new InvalidOperationException(nameof(span));
  }
}
