﻿
using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ReadOnlySpan<byte> AsBytesUnmanaged<T>(in ReadOnlySpan<T> span) where T : unmanaged
  {
    return MemoryMarshal.AsBytes(span);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<byte> AsBytesUnmanaged<T>(in Span<T> span) where T : unmanaged
  {
    return MemoryMarshal.AsBytes(span);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ReadOnlySpan<byte> AsBytesUnmanaged<T>(in ReadOnlySpan<T> span, in int start) where T : unmanaged
  {
    return MemoryMarshal.AsBytes(span[start..]);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<byte> AsBytesUnmanaged<T>(in Span<T> span, in int start) where T : unmanaged
  {
    return MemoryMarshal.AsBytes(span[start..]);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ReadOnlySpan<byte> AsBytesUnmanaged<T>(in ReadOnlySpan<T> span, in int start, in int length) where T : unmanaged
  {
    return MemoryMarshal.AsBytes(span.Slice(start, length));
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static Span<byte> AsBytesUnmanaged<T>(in Span<T> span, in int start, in int length) where T : unmanaged
  {
    return MemoryMarshal.AsBytes(span.Slice(start, length));
  }
}
