﻿

using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ref readonly T AsRefUnmanaged<T>(in ReadOnlySpan<byte> bytes) where T : unmanaged
  {
    return ref MemoryMarshal.AsRef<T>(bytes);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ref T AsRefUnmanaged<T>(in Span<byte> bytes) where T : unmanaged
  {
    return ref MemoryMarshal.AsRef<T>(bytes);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ref readonly T AsRefUnmanaged<T>(in ReadOnlySpan<byte> bytes, in int start) where T : unmanaged
  {
    return ref MemoryMarshal.AsRef<T>(bytes[start..]);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static ref T AsRefUnmanaged<T>(in Span<byte> bytes, in int start) where T : unmanaged
  {
    return ref MemoryMarshal.AsRef<T>(bytes[start..]);
  }

}
