﻿

using System.Runtime.CompilerServices;
using System.Runtime.InteropServices;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static void CopyUnmanaged<TSrc, TDest>(
    in ReadOnlySpan<TSrc> src, in int startsrc, in Span<TDest> dst, in int startdst, in int countsrc)
    where TSrc : unmanaged where TDest : unmanaged
  {
    var sztdest = SizeOfTUnmanaged<TDest>();
    var bytes = MemoryMarshal.AsBytes(src.Slice(startsrc, countsrc));

    var startdstbytes = startdst * sztdest;
    var bytesdst = MemoryMarshal.AsBytes(dst);
    SpanCopyBytes(bytes, 0, bytesdst, startdstbytes, bytes.Length);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  private unsafe static void SpanCopyBytes(
    in ReadOnlySpan<byte> src, in int startsrc, in Span<byte> dst, in int startdst, in int countdst)
  {
    fixed (byte* ptr = &src[startsrc])
      new Span<byte>(ptr, countdst).CopyTo(dst.Slice(startdst, countdst));
  }


}
