﻿
using System.Runtime.CompilerServices;
using System.Text;

namespace exc.jdbi.Spans;


partial class SpanTool
{

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static string ToStringUnmanaged<T>(
    in Span<T> span, in string separator = "") where T : unmanaged
  {
    return ToStringUnmanaged(span, 0, span.Length, separator);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static string ToStringUnmanaged<T>(
    in Span<T> span, in int start, in string separator = "") where T : unmanaged
  {
    return ToStringUnmanaged(span, start, span.Length - start, separator);
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static string ToStringUnmanaged<T>(
    in Span<T> span, in int start, in int length, in string separator = "") where T : unmanaged
  {
    if (span.Length == 0) return string.Empty;
    if (span.Length - start - length < 0) return string.Empty;
    var result = new StringBuilder(length);
    var spanresult = span.Slice(start, length);
    for (var i = 0; i < length; i++)
      result.Append(separator + spanresult[i].ToString());
    return result.ToString();
  }

  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static string ToStringUnmanaged<T>(
    in ReadOnlySpan<T> span, in string separator = "") where T : unmanaged
  {
    return ToStringUnmanaged(span, 0, span.Length, separator);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static string ToStringUnmanaged<T>(
    in ReadOnlySpan<T> span, in int start, in string separator = "") where T : unmanaged
  {
    return ToStringUnmanaged(span, start, span.Length - start, separator);
  }


  [SkipLocalsInit]
  [MethodImpl(MethodImplOptions.AggressiveInlining)]
  public static string ToStringUnmanaged<T>(
    in ReadOnlySpan<T> span, in int start, in int length, in string separator = "") where T : unmanaged
  {
    if (span.Length == 0) return string.Empty;
    if (span.Length - start - length < 0) return string.Empty;
    var result = new StringBuilder(length);
    var spanresult = span.Slice(start, length);
    for (var i = 0; i < length; i++)
      result.Append(separator + spanresult[i].ToString());
    return result.ToString();
  }
}
