﻿

using System.Runtime.InteropServices;

namespace SpanToolTest;

internal class RandomHolder
{

  public readonly static Random Rand = new Random();

  public static byte[] RngBytes(int size)
  {
    var result = new byte[size];
    Rand.NextBytes(result);
    return result;
  }

  public static T[] RngInts<T>(int size) where T : struct
  {
    int sz = Marshal.SizeOf(typeof(T));
    sz = typeof(T) == typeof(char) ? 2 : sz;
    sz = typeof(T) == typeof(bool) ? 1 : sz;
    var result = new T[size];
    var bytes = RngBytes(size * sz);
    Buffer.BlockCopy(bytes, 0, result, 0, bytes.Length);
    return result;
  }

  public static T RngInt<T>() where T : struct
  {
    int r = Rand.Next(2, 6);
    return RngInts<T>(r)[1];
  }

}