﻿

using exc.jdbi.Spans; 

namespace SpanToolTest;

using static RandomHolder;

internal class TestSpanToolUnmanaged
{
  public static void Start()
  {
    TestCopy();
    TestConvert();
    TestConvertNumber();
  }

  private static void TestConvertNumber()
  {
    var ui = RngInt<uint>();
    var i16 = SpanTool.ConvertToUnmanaged<uint, short>(ui); 

    var c = RngInt<char>();
    i16 = SpanTool.ConvertToUnmanaged<char, short>(c); 
  }

  private static void TestConvert( )
  {

    var uints = RngInts<uint>(Rand.Next(128, 512) - 1);
    var int16s = SpanTool.ConvertUnmanaged<uint, short>(uints);

    uints = RngInts<uint>(Rand.Next(128, 512) - 1);
    var chars = SpanTool.ConvertUnmanaged<uint, char>(uints).ToArray(); 


  }

  private static void TestCopy()
  {
    var bytes = RngBytes(Rand.Next(128, 1025));
    var dest = new byte[bytes.Length];
    SpanTool.Copy<byte>(bytes, 0, dest, 0, bytes.Length);

    var uints = RngInts<uint>(Rand.Next(128, 512) - 1);
    bytes = RngBytes(uints.Length * SpanTool.SizeOfT(uints[0].GetType()));
    SpanTool.CopyUnmanaged<uint, byte>(uints, 0, bytes, 0, uints.Length);
 
  } 

}