Option Strict On
Option Explicit On
Imports System.Runtime.InteropServices


Friend Module RandomHolder

  Public ReadOnly Rand As New Random

  Public Function RngBytes(size As Int32) As Byte()
    Dim result = New Byte(size - 1) {}
    Rand.NextBytes(result)
    Return result
  End Function

  Public Function RngInts(Of T As Structure)(size As Int32) As T()
    Dim sz = Marshal.SizeOf(GetType(T))
    sz = If(GetType(T) = GetType(Char), 2, sz)
    sz = If(GetType(T) = GetType(Boolean), 1, sz)

    Dim result = New T(size - 1) {}
    Dim bytes = RngBytes(size * sz)
    Buffer.BlockCopy(bytes, 0, result, 0, bytes.Length)
    Return result
  End Function

  Public Function RngInt(Of T As Structure)() As T
    Dim r = Rand.Next(2, 6)
    Return RngInts(Of T)(r)(1)
  End Function

End Module